//+------------------------------------------------------------------+
//|                                        Dolly Open (backtest).mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//|                                        by THEPIPHUNTER                          |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 5
#property  indicator_color1  Silver
#property  indicator_color2  Red
#property  indicator_color3  Blue
#property  indicator_color4  Red
#property  indicator_color5  Blue


//---- input parameters

extern int DailyOpen=0;

//---- buffers
double DailyOpenBuffer[];
double BuyLineBuffer[]; 
double SellLineBuffer[]; 
double TargetBuyBuffer[]; 
double TargetSellBuffer[]; 


//---- variables
int indexbegin = 0;
double dailyopen = 0; 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
	SetIndexStyle(0, DRAW_LINE, STYLE_DOT);
	SetIndexBuffer(0, DailyOpenBuffer);
	SetIndexLabel(0, "Daily Open");
	SetIndexEmptyValue(0, 0.0);
	
	SetIndexStyle(1, DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(1, BuyLineBuffer);

   SetIndexStyle(2, DRAW_LINE,STYLE_SOLID, 1);
   SetIndexBuffer(2, SellLineBuffer);

   SetIndexStyle(3, DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(3, TargetBuyBuffer);

   SetIndexStyle(4, DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(4, TargetSellBuffer);

   


//----
	indexbegin = Bars - 20;
	if (indexbegin < 0)
		indexbegin = 0;

	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator function                                        |
//+------------------------------------------------------------------+
int deinit()
{
	
//----
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int i;
	int counted_bars = IndicatorCounted();

	
	//---- check for possible errors
	if (counted_bars < 0) counted_bars = 0;
	//---- last counted bar will be recounted
	if (counted_bars > 0) counted_bars--;
	if (counted_bars > indexbegin) counted_bars = indexbegin;


		for (i = indexbegin-counted_bars; i >= 0; i--)
		{
			if ((TimeMinute(Time[i]) == 0) && (TimeHour(Time[i]) - DailyOpen == 0))
				dailyopen = Open[i];
			DailyOpenBuffer[i] = dailyopen;
			
         BuyLineBuffer[i] = dailyopen+(40*Point);
         SellLineBuffer[i] = dailyopen+(-40*Point);
         TargetBuyBuffer[i] = dailyopen-(20*Point);
         TargetSellBuffer[i] = dailyopen-(-20*Point);
         
			}

	
	return(0);

}
//+------------------------------------------------